unit Unit1; 

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, SdfData, db, FileUtil, Forms, Controls, Graphics, Dialogs,
  StdCtrls, DBGrids;

type

  { TForm1 }

  TForm1 = class(TForm)
    Button1: TButton;
    CheckBox1: TCheckBox;
    Datasource1: TDatasource;
    DBGrid1: TDBGrid;
    Edit1: TEdit;
    Label1: TLabel;
    SdfDataSet1: TSdfDataSet;
    procedure Button1Click(Sender: TObject);
    procedure CheckBox1Change(Sender: TObject);
    procedure Edit1Change(Sender: TObject);
    procedure SdfDataSet1FilterRecord(DataSet: TDataSet; var Accept: Boolean);
  private
    { private declarations }
  public
    { public declarations }
  end; 

var
  Form1: TForm1; 

implementation

{$R *.lfm}

{ TForm1 }

procedure TForm1.Button1Click(Sender: TObject);
begin
  Datasource1.DataSet := SdfDataSet1;
  SdfDataSet1.Open;
end;

procedure TForm1.CheckBox1Change(Sender: TObject);
begin
  SdfDataset1.Filtered := true;
  SdfDataset1.Refresh;
end;

procedure TForm1.Edit1Change(Sender: TObject);
begin
  SdfDataset1.Filtered := true;
  SdfDataset1.Refresh;
end;

procedure TForm1.SdfDataSet1FilterRecord(DataSet: TDataSet;
  var Accept: Boolean);
var
  s: String;
begin
  if Edit1.Text <> '' then begin
    s := SdfDataset1.FieldByName('MTRL_BTCH').AsString;
    Accept := pos(Edit1.Text, s) = 1;
  end;
  if Accept and Checkbox1.Checked then begin
    s := SdfDataset1.FieldByName('MTRL_TYPE').AsString;
    Accept := s = 'FERT';
  end;
end;

end.

